#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "kite_object.h"
#include "kite_vm.h"

#include "digest/md5.h"

KITE_CLASS_METHOD(Digest_md5file)
{
  //grab the file argument
  kite_object_t *arg1 = args->builtin_data.listvalue.car;
  kite_object_t *file = arg1;
  FILE *inFile = file->builtin_data.filevalue;
  //prepare the md5 state
  md5_state_t mdContext;
  int bytes, i;
  unsigned char data[1024];
  char *output = malloc(sizeof(char) * 33);
  md5_byte_t *final = malloc(sizeof(md5_byte_t) * 16);

  KITE_THIS_NOT_USED;  

  //make sure the file is valid
  if (inFile == NULL) {
      kite_object_t *exc;
      exc = kite_new_exception(thd, "System.exceptions.FileError", "File Not Found");
      kite_vm_call_method(thd, exc, "throw", kite_new_list(thd), TRUE);
      return;
  }
  
  //md5 the file
  md5_init (&mdContext);
  while ((bytes = fread (data, 1, 1024, inFile)) != 0)
  {
    md5_append (&mdContext, data, bytes);
  }
  md5_finish (&mdContext,final);
  // turn into a hex string
  for (i = 0; i < 16; i++)
     sprintf (&output[i*2], "%02x", final[i]);
   
  kite_vm_return(thd, kite_new_string(thd, output));
  
  
}

KITE_CLASS_METHOD(Digest_md5)
{   
   //grab the string argument
   kite_object_t *arg1 = args->builtin_data.listvalue.car;
   kite_object_t *name = kite_string_object(thd, arg1);
   char *input = name->builtin_data.stringvalue.string;
   int i;
   
   //prepare md5 state
   md5_state_t mdContext;
   char *output = malloc(sizeof(char) * 33);
   md5_byte_t *final = malloc(sizeof(md5_byte_t) * 16);
   
   unsigned int len = strlen (input);

   KITE_THIS_NOT_USED;

   //md5 the input string
   md5_init (&mdContext);
   md5_append (&mdContext, (unsigned char *)input, len);
   md5_finish (&mdContext,final);
   // turn into a hex string
   for (i = 0; i < 16; i++)
     sprintf (&output[i*2], "%02x", (unsigned char)final[i]);
   
   kite_vm_return(thd, kite_new_string(thd, output));
   
}

KITE_MODULE_INITIALIZER(digest)
{
   kite_object_t *inherits =
        kite_dereference_and_load(thread, "System.object");
    kite_object_t *newclass =
       kite_new_class(thread, inherits, "digest");
   kite_set_docstring(newclass, "Generate cryptographic digests.");
   
   kite_add_method(thread, newclass, "md5",
       kite_new_method_compiled_with_docs(thread, Digest_md5,
                                 "Generate an MD5 digest of a string.", 1,
                                 "message","The message of which we shall obtain a digest."));
                                 
   kite_add_method(thread, newclass, "md5file",
       kite_new_method_compiled_with_docs(thread, Digest_md5file,
                                 "Generate an MD5 digest of a file.", 1,
                                 "file","The file of which we shall obtain a digest."));
   
  /* Add to parent to complete loading. */
  kite_add_property(thread, parent, "digest", 1, NULL);
  kite_set_property(thread, parent, "digest", newclass);
}
//int main () {}
